/*
 * Copyright (c) 1987, 1988, 1989 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Stanford not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Stanford makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * STANFORD DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL STANFORD BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * RubberGroup - a group of Rubberbands to track simultaneously.
 */

#ifndef rubgroup_h
#define rubgroup_h

#include <InterViews/rubband.h>

class RubberGroup : public Rubberband {
public:
    RubberGroup(Painter*, Canvas*);
    virtual ~RubberGroup();

    virtual void Draw();
    virtual void Erase();
    virtual void Track(Coord, Coord);
    virtual void SetPainter(Painter*);
    virtual void SetCanvas(Canvas*);

    void Append(
	Rubberband*, Rubberband* = nil, Rubberband* = nil, Rubberband* = nil
    );
    void Remove(Rubberband*);
    void RemoveCur();
    void SetCurrent(Rubberband*);
    Rubberband* GetCurrent();
    Rubberband* First();
    Rubberband* Last();
    Rubberband* Next();
    Rubberband* Prev();
    boolean IsEmpty();
    boolean AtEnd();
private:
    class RubberList* list, *cur;
};

#endif
